C	***********************************************************
C	DIALOG-ROUTINES TO INPUT GRAIN- AND SURROUNDING PARAMETERS
C	***********************************************************
	SUBROUTINE PHYSPAR
	REAL REFMED,MUEMED,RAD
	CHARACTER KORR
	COMMON /PHYS/ REFMED,MUEMED,RAD

10	FORMAT (////)
	WRITE (6,10)
12	FORMAT (' (Real) refractive index of surrounding medium : ',$)
260	WRITE (6,12)
	READ (5,*) REFMED
13	FORMAT (' (Real) permeability of surrounding medium     : ',$)
	WRITE (6,13)
	READ (5,*) MUEMED
15	FORMAT (' Medium radius of grains [cm]                  : ',$)
	WRITE (6,15)
	READ (5,*) RAD
C	***********************************************************
C	ASK FOR KORRECTION AND REBEGINNING IF WANTED
C	***********************************************************
25	FORMAT (/,' You have chosen the following parameters : ')
	WRITE (6,25)
32	FORMAT (/,' N(MED)=',G11.4,' MUE(MED)=',G11.4,' RADIUS=',G11.4)
	WRITE (6,32) REFMED,MUEMED,RAD
33	FORMAT (/,' Is this what you want ? ',$)
	WRITE (6,33)
39	FORMAT (A1)
	READ (5,39)KORR
	IF(KORR.NE.'Y'.AND.KORR.NE.'y') GOTO 260
	RETURN
	END

C       ***********************************************************
C       ROUTINES TO READ THE FILE CONTAINING THE OPTICAL CONSTANTS
C       OF ONE MEDIUM
C       ***********************************************************
        SUBROUTINE READMUFILE(ZI,NI,KI,MURI,MUII,M,NAME)
        INTEGER LOGI,M,ML,I
        REAL LI(256),KI(256),ZI(256),NI(256),MURI(256),MUII(256),HLP
        CHARACTER*64 LFILE,LFILEM
        CHARACTER*10 NAME
        CHARACTER YN

11      FORMAT (' Name of file of optical constants: ',$)
14      FORMAT (' This file has an illegal extension ! ',/)
30      FORMAT (A64)
100     WRITE (6,11)
        READ (5,30) LFILE
        CALL NAMECHEC(LFILE,NAME,LOGI)
        IF(LOGI.NE.0) GOTO 140
        WRITE (6,14)
        GOTO 100
C       ***********************************************************
C       LOADING LINE PARAMETERS FROM FILE CALLED LFILE
C       ***********************************************************
140     OPEN(12,ERR=120,FILE=LFILE,STATUS='OLD')
        DO 190 I=1,256
190     READ (12,FMT=*,END=110) ZI(I),NI(I),KI(I)
110     CLOSE (12)
        M=I-1
18      FORMAT (' Is there any permeability file ? ',$)
19      FORMAT (A1)
        WRITE (6,18)
        READ (5,19) YN
        IF (YN.EQ.'y'.OR.YN.EQ.'Y') THEN
C       ***********************************************************
C       READING THE PERMEABILITY FILE
C       ***********************************************************
        CALL NAMEPERM(LFILE,LFILEM,LOGI)
        OPEN(12,ERR=130,FILE=LFILEM,STATUS='OLD')
        DO 195 I=1,256
195     READ (12,FMT=*,END=115) LI(I),MURI(I),MUII(I)
115     CLOSE (12)
        ML=I-1
C       ***********************************************************
C       CHECK CONSISTENCY OF BOTH FILES
C       ***********************************************************
        IF (M.NE.ML.OR.ZI(1).NE.LI(1).OR.ZI(M).NE.LI(ML)) GOTO 210      
        ELSE
        DO 310 I=1,M
        MURI(I)=1.0
310     MUII(I)=0.0
        ENDIF
12      FORMAT (' Number of lines in the file(s)   : ',I5)
        WRITE (6,12) M
C       **********************************************************
C       REDUCTION WAVELENGTH, N AND K DEPENDING ON LOGI
C       **********************************************************
        IF (LOGI.LT.0) THEN
        DO 160 I=1,M
160     ZI(I)=1.0/ZI(I)
        ENDIF
        IF (ABS(LOGI).EQ.2) THEN
        DO 320 I=1,M
        HLP=SQRT(NI(I)**2+KI(I)**2)
        KI(I)=SQRT(0.5*(HLP-NI(I)))
320     NI(I)=SQRT(0.5*(HLP+NI(I)))
        ENDIF
        RETURN
C       **********************************************************
C       EXCEPTION HANDLING
C       **********************************************************
13      FORMAT (' There is no access to file       : ',A64,/)
17      FORMAT (' Files of opt.constants and permeability are',
     %  ' inconsistent!')
120     WRITE (6,13) LFILE
        GOTO 100
130     WRITE (6,13) LFILEM
        GOTO 100
210     WRITE (6,17)
        GOTO 100
        END

C       *************************************************************
C       CHECK IF THE FILE IS A ".LNK", ".ZNK" OR ".LEE"-FILE
C       RECOGNITION OF THE TITLE OF THE SPECTRUM
C       *************************************************************
        SUBROUTINE NAMECHEC(FILEN,NAME,LZ)
        INTEGER EXA,NME,LZ,LZH
        CHARACTER*10 NAME
        CHARACTER*64 FILEN,HNAME,HFNAME
        CHARACTER*1 EXT1
        CHARACTER*2 EXT2
        CHARACTER*3 EXTENS

        HNAME=FILEN
200     EXA=INDEX(HNAME,'/')+1
        IF (EXA.GT.1) THEN
        HNAME=HNAME(EXA:)
        GOTO 200
        ELSE
        HFNAME=HNAME
        ENDIF

        HNAME=HFNAME
        NME=0
100     EXA=INDEX(HNAME,'.')+1
        IF (EXA.GT.1) THEN
        HNAME=HNAME(EXA:)
        NME=NME+EXA-1
        GOTO 100
        ELSE
        EXTENS=HNAME
        EXT1=EXTENS(:1)
        EXT2=EXTENS(2:)
        NAME=HFNAME(:MAX0(0,NME-1))
        ENDIF

        LZ=0
        IF(EXT2.EQ.'NK'.OR.EXT2.EQ.'nk') LZ=1
        IF(EXT2.EQ.'EE'.OR.EXT2.EQ.'ee') LZ=2
        LZH=0
        IF(EXT1.EQ.'L'.OR.EXT1.EQ.'l') LZH=1
        IF(EXT1.EQ.'Z'.OR.EXT1.EQ.'z') LZH=-1
        LZ=LZ*LZH
        RETURN
        END

C       *************************************************************
C       CONSTRUCTION OF THE NAME OF THE PERMEABILITY FILE
C       *************************************************************
        SUBROUTINE NAMEPERM(FILEN,FILEM,LZ)
        INTEGER EXA,NME,LZ
        CHARACTER*64 FILEN,FILEM,HNAME
        CHARACTER*3 EXTL,EXTZ
        DATA EXTL,EXTZ/'lmu','zmu'/

        HNAME=FILEN
        NME=0
100     EXA=INDEX(HNAME,'.')+1
        IF (EXA.GT.1) THEN
        HNAME=HNAME(EXA:)
        NME=NME+EXA-1
        GOTO 100
        ENDIF

        IF (LZ.GT.0) THEN
        FILEM=FILEN(1:NME)//EXTL
        ELSE
        FILEM=FILEN(1:NME)//EXTZ
        ENDIF
        RETURN
        END

C	***********************************************************
C	ROUTINE TO INPUT NAME OF WRITE FILE
C	***********************************************************
	SUBROUTINE NAMEREAD(LFILE)
	CHARACTER*40 LFILE(3),BASE
	INTEGER NPOINT

21	FORMAT (' File name for the resulting efficiencies      : ',$)
	WRITE (6,21)
22	FORMAT (A40)
	READ (5,22) BASE
	NPOINT=INDEX(BASE,'.')
	IF (NPOINT.EQ.0) NPOINT=INDEX(BASE,' ')
	LFILE(1)=BASE(:NPOINT-1)//'.lqa'
	LFILE(2)=BASE(:NPOINT-1)//'.lsc'
	LFILE(3)=BASE(:NPOINT-1)//'.lg'
	RETURN
	END

C	**********************************************************
C	ROUTINE TO WRITE QABS/QSCA INTO LFILE
C	**********************************************************
	SUBROUTINE QAWRITE(WAVEL,QABS,N,LFILE)
	REAL WAVEL(256),QABS(256)
	INTEGER N,I
	CHARACTER*40 LFILE

	OPEN(12,ERR=180,FILE=LFILE,STATUS='NEW')
21	FORMAT (' ',E11.5,' ',E11.5)
	WRITE (12,21) (WAVEL(I),QABS(I),I=1,N)
	CLOSE (12)
	RETURN
27	FORMAT (/,' This file exists already : ',A40)
180	WRITE (6,27) LFILE
	END

